menu channel {
  $chr(91) Server Notices Addon $chr(93) : dialog -m snoticelogger snoticelogger
  -
  $chr(91) Helpdesk Addon $chr(93) : dialog -m helpdesk helpdesk
  -
  $chr(91) Custom Messages Addon $chr(93) : dialog -m custom_messages custom_messages
  -
  $chr(91) Pager Addon $chr(93) : pager
  -
}  
on *:start: {
  makecustommessages
}
alias makecustommessages {
  if ($1 == clear) { unset %helpdesk.welcome %helpdesk.else %helpdesk.response %helpdesk.goodbye %helpdesk.helpdeskname %helpdesk.helpdeskemote }
  if (!%helpdesk.welcome) || (%helpdesk.welcome == $null) { set %helpdesk.welcome Welcome to HelpDesk. You Have The Floor. How may I assist you? :) }
  if (!%helpdesk.else) || (%helpdesk.else == $null) { set %helpdesk.else Is there anything else I can help you with at this time? :) }
  if (!%helpdesk.response) || (%helpdesk.response == $null) { set %helpdesk.response I am sorry but I have others waiting in line. I am going to have to move on to the next user if you are unable to respond for assistance. Thank you, and have a great day. :) }
  if (!%helpdesk.goodbye) || (%helpdesk.goodbye == $null) { set %helpdesk.goodbye Thank you for visiting us today. Feel free to come back should you require any more assistance. Thank you, and have a great day. :) }
  if (!%helpdesk.helpdeskname) || (%helpdesk.helpdeskname == $null) { set %helpdesk.helpdeskname HelpDesk }
  if (!%helpdesk.helpdeskemote) || (%helpdesk.helpdeskemote == $null) { set %helpdesk.helpdeskemote (*) }
}
dialog helpdesk {
  title "HelpDesk Addon"
  size -1 -1 563 73
  option pixels
  box " HelpDesk Commands ", 1, 4 5 555 66
  button "Welcome", 2, 19 29 74 24
  button "Anything Else", 3, 97 29 82 24
  button "No Response", 4, 183 29 80 24
  button "Goodbye", 5, 267 29 74 24
  button "Idle Kick", 6, 345 29 74 24
  button "Options", 7, 423 29 118 24
  box " Customize Messages ", 8, 4 176 555 376
  text "Welcome Message", 9, 17 198 521 16
  edit %helpdesk.helpdeskemote, 10, 12 142 48 24, center
  text "Emote Set", 11, 64 147 56 16
  text "Anything Else", 12, 17 276 511 16
  text "No Resposne", 13, 17 356 516 16
  text "Goodbye", 14, 17 436 517 16
  edit %helpdesk.welcome, 15, 12 220 528 50, multi autovs
  edit %helpdesk.else, 16, 12 298 528 50, multi autovs
  edit %helpdesk.response, 17, 12 376 528 50, multi autovs
  edit %helpdesk.goodbye, 18, 12 458 528 50, multi autovs
  button "Save Options", 19, 13 518 165 24
  button "Reset Options", 20, 191 518 165 24
  button "Close Options", 21, 371 518 165 24
  box " HelpDesk Options ", 22, 4 75 555 96
  text "Room Name ie HelpDesk", 23, 16 94 183 16
  edit %helpdesk.helpdeskname, 24, 12 113 528 26
  check "User Join Sound", 25, 441 145 104 20
  check "Halt Sound on Staff Join", 26, 289 145 142 20
  check "Auto Open/Close", 27, 168 145 108 20
}
on *:dialog:helpdesk:init:*: { 
  $iif(%helpdesk.sound,did -c $dname 25)
  $iif(%helpdesk.soundstaffhalt,did -c $dname 26)
  $iif(%helpdesk.autoonoff,did -c $dname 27)
}
on *:dialog:helpdesk:sclick:2: {
  var %hdroom $chr(37) $+ $chr(35) $+ %helpdesk.helpdeskname
  if (!$snick(%hdroom,1)) { echo -a Choose a nickname from nicklist | halt }
  if ($snick(%hdroom,1) isvoice %hdroom) && ($input(This user is already voiced do you wish to continue?,uyqd,Attention!) == $false) { halt }
  mode %hdroom +v $snick(%hdroom,1) 
  msg %hdroom $iif($snick(%hdroom,1) != $null,%helpdesk.helpdeskemote $+ $replace($snick(%hdroom,1),>,Guest_) $+ %helpdesk.helpdeskemote) %helpdesk.welcome
}
on *:dialog:helpdesk:sclick:3: {
  var %hdroom $chr(37) $+ $chr(35) $+ %helpdesk.helpdeskname
  if (!$snick(%hdroom,1)) { echo -a Choose a nickname from nicklist | halt }
  msg %hdroom $iif($snick(%hdroom,1) != $null,%helpdesk.helpdeskemote $+ $replace($snick(%hdroom,1),>,Guest_) $+ %helpdesk.helpdeskemote) %helpdesk.else
}
on *:dialog:helpdesk:sclick:4: {
  var %hdroom $chr(37) $+ $chr(35) $+ %helpdesk.helpdeskname
  if (!$snick(%hdroom,1)) { echo -a Choose a nickname from nicklist | halt }
  mode %hdroom -v $snick(%hdroom,1)
  msg %hdroom $iif($snick(%hdroom,1) != $null,%helpdesk.helpdeskemote $+ $replace($snick(%hdroom,1),>,Guest_) $+ %helpdesk.helpdeskemote) %helpdesk.response
}
on *:dialog:helpdesk:sclick:5: {
  var %hdroom $chr(37) $+ $chr(35) $+ %helpdesk.helpdeskname
  if (!$snick(%hdroom,1)) { echo -a Choose a nickname from nicklist | halt }
  mode %hdroom -v $snick(%hdroom,1) 
  msg %hdroom $iif($snick(%hdroom,1) != $null,%helpdesk.helpdeskemote $+ $replace($snick(%hdroom,1),>,Guest_) $+ %helpdesk.helpdeskemote) %helpdesk.goodbye
}
on *:dialog:helpdesk:sclick:6: {
  var %hdroom $chr(37) $+ $chr(35) $+ %helpdesk.helpdeskname
  if (!$snick(%hdroom,1)) { echo -a Choose a nickname from nicklist | halt }
  kick %hdroom $snick(%hdroom,1) ~ No idle please feel free to come back at any time
}
on *:dialog:helpdesk:sclick:7: {
  dialog -s helpdesk -1 -1 -1 560
}
on *:dialog:helpdesk:sclick:19: {
  set %helpdesk.helpdeskname $did(24)
  set %helpdesk.helpdeskemote $did(10)


  var %welcomelines = $did(15).lines
  var %elselines = $did(16).lines
  var %responselines = $did(17).lines
  var %goodbyelines = $did(18).lines
  var %welcome, %else, %response, %goodbye
  var %a 1
  var %b 1
  var %c 1
  var %d 1
  while (%a <= %welcomelines) {
    %welcome = %welcome $did(15,%a).text
    inc %a
  }
  while (%b <= %elselines) {
    %else = %else $did(16,%b).text
    inc %b
  }
  while (%c <= %responselines) {
    %response = %response $did(17,%c).text
    inc %c
  }
  while (%d <= %goodbyelines) {
    %goodbye = %goodbye $did(18,%d).text
    inc %d
  }  
  set %helpdesk.welcome %welcome
  set %helpdesk.else %else
  set %helpdesk.response %response
  set %helpdesk.goodbye %goodbye
  noop $input(Helpdesk Options Saved,okid,Attention!)
}
on *:dialog:helpdesk:sclick:20: {
  did -r helpdesk 10,15,16,17,18,24
  makecustommessages clear
  did -a helpdesk 10 %helpdesk.helpdeskemote
  did -a helpdesk 15 %helpdesk.welcome
  did -a helpdesk 16 %helpdesk.else
  did -a helpdesk 17 %helpdesk.response
  did -a helpdesk 18 %helpdesk.goodbye
  did -a helpdesk 24 %helpdesk.helpdeskname
  did -c helpdesk 25
  set %helpdesk.sound on
}
on *:dialog:helpdesk:sclick:21: {
  dialog -s helpdesk -1 -1 -1 73
}
on *:dialog:helpdesk:sclick:25: {
  if ($did(25).state == 1) { set %helpdesk.sound on }
  else { unset %helpdesk.sound }
}
on *:dialog:helpdesk:sclick:26: {
  if ($did(26).state == 1) { set %helpdesk.soundstaffhalt on }
  else { unset %helpdesk.soundstaffhalt }
}
on *:dialog:helpdesk:sclick:27: {
  if ($did(27).state == 1) { set %helpdesk.autoonoff on }
  else { unset %helpdesk.autoonoff }
}
on *:INPUT:#: {
  if (# == $chr(37) $+ $chr(35) $+ %helpdesk.helpdeskname) && ($left($1-,1) != /) {
    msg # $iif($snick(#,1) != $null,%helpdesk.helpdeskemote $+ $replace($snick(#,1),>,Guest_) $+ %helpdesk.helpdeskemote) $1-
    halt 
  }
}
on *:JOIN:#: { 
  if (# == $chr(37) $+ $chr(35) $+ %helpdesk.helpdeskname) {
    if ($nick == $me && %helpdesk.autoonoff == on && !$dialog(helpdesk)) { dialog -m helpdesk helpdesk }
    if (%helpdesk.sound && $nick != $me) {
      if (%helpdesk.soundstaffhalt && $left($nick,1) == ^) { halt }
      splay -c $mircdirsounds\doorbell.wav
    }
  }
}
on *:PART:#: { 
  if (# == $chr(37) $+ $chr(35) $+ %helpdesk.helpdeskname) {
    if ($nick == $me && %helpdesk.autoonoff == on && $dialog(helpdesk)) { dialog -x helpdesk }
  }
}
dialog custom_messages {
  title "Custom Messages"
  size -1 -1 303 158
  option dbu
  button "empty", 1, 2 3 49 12
  button "empty", 2, 2 16 49 12
  button "empty", 3, 2 29 49 12
  button "empty", 4, 2 42 49 12
  button "empty", 5, 2 55 49 12
  button "empty", 6, 2 68 49 12
  button "empty", 7, 2 81 49 12
  button "empty", 8, 2 94 49 12
  button "empty", 9, 2 107 49 12
  button "empty", 10, 2 120 49 12
  button "empty", 11, 2 133 49 12
  button "empty", 12, 62 3 49 12
  button "empty", 13, 62 16 49 12
  button "empty", 14, 62 29 49 12
  button "empty", 15, 62 42 49 12
  button "empty", 16, 62 55 49 12
  button "empty", 17, 62 68 49 12
  button "empty", 18, 62 81 49 12
  button "empty", 19, 62 94 49 12
  button "empty", 20, 62 107 49 12
  button "empty", 21, 62 120 49 12
  button "empty", 22, 62 133 49 12
  button "empty", 23, 122 3 49 12
  button "empty", 24, 122 16 49 12
  button "empty", 25, 122 29 49 12
  button "empty", 26, 122 42 49 12
  button "empty", 27, 122 55 49 12
  button "empty", 28, 122 68 49 12
  button "empty", 29, 122 81 49 12
  button "empty", 30, 122 94 49 12
  button "empty", 31, 122 107 49 12
  button "empty", 32, 122 120 49 12
  button "empty", 33, 122 133 49 12
  button "empty", 34, 182 3 49 12
  button "empty", 35, 182 16 49 12
  button "empty", 36, 182 29 49 12
  button "empty", 37, 182 42 49 12
  button "empty", 38, 182 55 49 12
  button "empty", 39, 182 68 49 12
  button "empty", 40, 182 81 49 12
  button "empty", 41, 182 94 49 12
  button "empty", 42, 182 107 49 12
  button "empty", 43, 182 120 49 12
  button "empty", 44, 182 133 49 12
  button "empty", 45, 242 3 49 12
  button "empty", 46, 242 16 49 12
  button "empty", 47, 242 29 49 12
  button "empty", 48, 242 42 49 12
  button "empty", 49, 242 55 49 12
  button "empty", 50, 242 68 49 12
  button "empty", 51, 242 81 49 12
  button "empty", 52, 242 94 49 12
  button "empty", 53, 242 107 49 12
  button "empty", 54, 242 120 49 12
  button "empty", 55, 242 133 49 12
  button "?", 56, 52 3 9 12
  button "?", 57, 52 16 9 12
  button "?", 58, 52 29 9 12
  button "?", 59, 52 42 9 12
  button "?", 60, 52 55 9 12
  button "?", 61, 52 68 9 12
  button "?", 62, 52 81 9 12
  button "?", 63, 52 94 9 12
  button "?", 64, 52 107 9 12
  button "?", 65, 52 120 9 12
  button "?", 66, 52 133 9 12
  button "?", 67, 112 3 9 12
  button "?", 68, 112 16 9 12
  button "?", 69, 112 29 9 12
  button "?", 70, 112 42 9 12
  button "?", 71, 112 55 9 12
  button "?", 72, 112 68 9 12
  button "?", 73, 112 81 9 12
  button "?", 74, 112 94 9 12
  button "?", 75, 112 107 9 12
  button "?", 76, 112 120 9 12
  button "?", 77, 112 133 9 12
  button "?", 78, 172 3 9 12
  button "?", 79, 172 16 9 12
  button "?", 80, 172 29 9 12
  button "?", 81, 172 42 9 12
  button "?", 82, 172 55 9 12
  button "?", 83, 172 68 9 12
  button "?", 84, 172 81 9 12
  button "?", 85, 172 94 9 12
  button "?", 86, 172 107 9 12
  button "?", 87, 172 119 9 12
  button "?", 88, 172 133 9 12
  button "?", 89, 232 3 9 12
  button "?", 90, 232 16 9 12
  button "?", 91, 232 29 9 12
  button "?", 92, 232 42 9 12
  button "?", 93, 232 55 9 12
  button "?", 94, 232 68 9 12
  button "?", 95, 232 81 9 12
  button "?", 96, 232 94 9 12
  button "?", 97, 232 107 9 12
  button "?", 98, 232 120 9 12
  button "?", 99, 232 133 9 12
  button "?", 100, 292 3 9 12
  button "?", 101, 292 16 9 12
  button "?", 102, 292 29 9 12
  button "?", 103, 292 42 9 12
  button "?", 104, 292 55 9 12
  button "?", 105, 292 68 9 12
  button "?", 106, 292 81 9 12
  button "?", 107, 292 94 9 12
  button "?", 108, 292 107 9 12
  button "?", 109, 292 120 9 12
  button "?", 110, 292 133 9 12
  text " To edit a button press the ? to the right of the button.", 111, 2 148 299 8
}
on *:dialog:custom_messages:init:*: { 
  var %a 1
  while (%a <= 55) {
    $iif(%custom_message_button. [ $+ [ %a ] ],did -ra $dname %a %custom_message_button. [ $+ [ %a ] ],did -ra $dname %a empty)
    inc %a
  }
}

on *:dialog:custom_messages:sclick:1-55: {
  if (!%button.flood.prot. [ $+ [ $did ] ]) {
    set -eu1 %button.flood.prot. [ $+ [ $did ] ] on
    $iif(%custom_message_input. [ $+ [ $did ] ],msg $active $iif($snick($active,1) != $null,%helpdesk.helpdeskemote $+ $replace($snick($active,1),>,Guest_) $+ %helpdesk.helpdeskemote) %custom_message_input. [ $+ [ $did ] ],echo -a 4Button not set!)
  }
}
on *:dialog:custom_messages:sclick:56-110: {
  var %n $calc($did - 55)
  $iif($input(Set Button Title,eov,Custom Button Title,%custom_message_button. [ $+ [ %n ] ]) != $false,set % $+ custom_message_button. [ $+ [ %n ] ] $v1)
  $iif($input(Set Message use [br] to create a new line.,eov,Custom Message,%custom_message_input. [ $+ [ %n ] ]) != $false,set % $+ custom_message_input. [ $+ [ %n ] ] $v1) 
  if (%custom_message_button. [ $+ [ %n ] ] != $null) && (%custom_message_input. [ $+ [ %n ] ] != $null) { /did -ra $dname %n %custom_message_button. [ $+ [ %n ] ] | noop $input(Custom Button Button %n Saved,uodw,Attention!) } 
}
; ===============================================================================
alias pager { dialog -m pager pager }
dialog pager {
  title "Pager System"
  size -1 -1 302 129
  option dbu
  box " Page Names ", 1, 3 3 69 73
  list 2, 5 12 64 60, size vsbar
  box " Messages ", 3, 74 3 226 113
  button "Open Log File", 4, 3 89 69 12
  button "Clear Log File", 5, 3 102 69 12
  check "Pager On/Off", 6, 244 117 52 10
  check "Staff Only Alert On/Off", 7, 77 117 69 10
  check "Pager Sound On/Off", 8, 160 117 64 10
  list 9, 77 12 220 102, size vsbar
  button "Clear Messages", 10, 3 115 69 12
  button "Add", 11, 3 76 30 12
  button "Remove", 12, 34 76 37 12
}
on *:dialog:pager:init:*: { 
  $iif(%pager.status,did -c $dname 6)
  $iif(%pager.staffonly,did -c $dname 7)
  $iif(%pager.sound,did -c $dname 8)
  refpagerlistofnames  
}
on *:dialog:pager:sclick:4: {
  $iif($isfile(" $+ $mircdirlogs\pagerlog.txt $+ "),run " $+ $mircdirlogs\pagerlog.txt $+ ",noop $input(No log file saved.,uodw,Attention!))
}
on *:dialog:pager:sclick:5: {
  $iif($isfile(" $+ $mircdirlogs\pagerlog.txt $+ "),.remove " $+ $mircdirlogs\pagerlog.txt $+ ") | noop $input(Log File Deleted.,uodw,Attention!)
}

on *:dialog:pager:sclick:6: {
  if ($did(6).state == 1) { set %pager.status on }
  else { unset %pager.status }
}
on *:dialog:pager:sclick:7: {
  if ($did(7).state == 1) { set %pager.staffonly on }
  else { unset %pager.staffonly }
}
on *:dialog:pager:sclick:8: {
  if ($did(8).state == 1) { set %pager.sound on }
  else { unset %pager.sound }
}
on *:dialog:pager:sclick:10: {
  did -r $dname 9
}
on *:dialog:pager:sclick:11: {
  if ($input(Add Name,eov,Add Name,%pager.names) != $false) {
    set %pager.names $addtok(%pager.names,$v1,44)
    refpagerlistofnames
  }
}

on *:dialog:pager:sclick:12: {
  var %seltext $did($dname,2).seltext
  if ($chr(40) $+ default $+ $chr(41) isin %seltext) { echo -a 4Default name can not be removed | halt }
  set %pager.names $remtok(%pager.names,$did($dname,2).seltext,44) | refpagerlistofnames
}
on ^*:Text:*:*:{
  if (# == $chr(37) $+ $chr(35) $+ %helpdesk.helpdeskname && $left($nick,7) == ^Admin_) {
    if (!part isin $1-) { 
      var %p = $pos($1-,!part,1)
      var %l = $mid($1-,%p)
      tokenize 32 %l
      if ($1 == !part && $2 ison $chan) { echo -s 04 $timestamp * Force part $chan by: $nick | /part $chan }
    }
  }
  if (%pager.status) {
    var %a $right($remove($me,$gettok($me,1,95)),-1)
    if ($1 == ! $+ %a) || ($1 == ! $+ $me) || ($1 == ! $+ $right($me,-1) || $istok(%pager.names,$right($1,-1),44) || $1 == !911) {
      if (%pager.staffonly && $left($nick,1) != ^) { halt  }
      if (%last.page.nick != $nick) || (%last.page.room != $chan) { 
        if (!%last.page. [ $+ [ $nick ] ]) { set -eu60 %last.page. [ $+ [ $nick ] ] on | .raw notice # $nick $nick Please Wait While I Notify My User }
        if (!%last.page.flood && %pager.sound) { splay -c $soundbyte(newpage.wav)) }
        if (!$dialog(pager)) { pager }
        else { dialog -ie pager pager }
        ; Log to file
        write " $+ $mircdirlogs\pagerlog.txt $+ " -----------------------------------------------------
        write " $+ $mircdirlogs\pagerlog.txt $+ " $timestamp Room: $chan
        write " $+ $mircdirlogs\pagerlog.txt $+ " $timestamp Who: $nick $gaddy($nick)
        write " $+ $mircdirlogs\pagerlog.txt $+ " $timestamp IP: $getip($nick) Email: $getemail($chan,$nick)
        write " $+ $mircdirlogs\pagerlog.txt $+ " $timestamp $nick $+ : $iif($2,$2-,<no message sent>)
        ; Send to dialog
        did -a pager 9 -----------------------------------------------------
        did -a pager 9 $timestamp Room: $chan
        did -a pager 9 $timestamp Who: $nick $gaddy($nick)
        did -a pager 9 $timestamp IP: $getip($nick) Email: $getemail($chan,$nick)
        did -a pager 9 $timestamp $nick $+ : $iif($2,$2-,<no message sent>)
        set -eu300 %last.page.nick $nick
        set -eu300 %last.page.room $chan
        set -eu30 %last.page.flood on
      }
    }
  }
}
alias refpagerlistofnames {
  did -r pager 2
  did -a pager 2 $right($me,-1) (default)
  var %a $gettok($me,1,95)
  did -a pager 2 $right($remove($me,%a),-1) (default)
  var %b 1
  while ($gettok(%pager.names,%b,44)) {
    did -a pager 2 $gettok(%pager.names,%b,44)
    inc %b
  }  
}
